﻿using Plane.Windows.IniHelper;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace Plane.FormationCreator.Util
{
    public static class VersionControl
    {
        private static string  DefaultServrURL= "http://111.229.174.37:81/login/";
        public static int Version = 0;
        /// <summary>
        /// 是否是完整版本 仅在Version = 255时为完整版本
        /// </summary>
        public static bool IsFullVersion = false;

        /// <summary>
        /// 默认的飞机上限
        /// </summary>
        public static int CopterUpperLimit = 50;

        public static string  Username = "";
        public static string Password = "";
        public static bool IssavePassword = false;

        public static string ServerURL = "";

        public static void SetUserLever(int vuserlever)
        {
            if (vuserlever==0)
                //管理员
                IsFullVersion = true;
            else
                IsFullVersion = false;
        }


        public static void GetSettingFromIni()
        {
            IniFiles iniFiles = new IniFiles();

            int intTemp;
            bool boolTemp;
            string readvalue;
            //完整版本和更多飞机数量通过网络授权或者超级用户得到
            
            /*
            readvalue = iniFiles.IniReadvalue("Version", "Version");
            if (readvalue != "" && int.TryParse(readvalue, out intTemp))
                Version = int.Parse(readvalue);
            IsFullVersion = Version == 255;

            readvalue = iniFiles.IniReadvalue("Version", "CopterUpperLimit");
            if (readvalue != "" && int.TryParse(readvalue, out intTemp))
                CopterUpperLimit = int.Parse(readvalue);
            */

            readvalue = iniFiles.IniReadvalue("Login", "Username");
            if (readvalue != "")
                Username = readvalue;

            readvalue = Decrypt(iniFiles.IniReadvalue("Login", "Password"));
            if (readvalue != "")
                Password = readvalue;


            readvalue = iniFiles.IniReadvalue("Login", "issavePassword");
            if (readvalue != "" && bool.TryParse(readvalue, out boolTemp))
                IssavePassword = bool.Parse(readvalue);

            readvalue = iniFiles.IniReadvalue("Default", "Server");
            if (readvalue != "")
                ServerURL = readvalue;
            else
                ServerURL = DefaultServrURL;








        }

        public static void SaveLogininfoToIni(string username,string password,bool issavepassword)
        {
            Username = username;
            Password = password;
            IssavePassword = issavepassword;
            IniFiles iniFiles = new IniFiles();
            iniFiles.IniWritevalue("Login", "Username", username);
            if (issavepassword)
                iniFiles.IniWritevalue("Login", "Password", Encrypt(password));
            else
                iniFiles.IniWritevalue("Login", "Password", "");

            iniFiles.IniWritevalue("Login", "issavepassword", issavepassword.ToString());



        }

        static string encryptKey = "fxmf";//字符串加密密钥(注意：密钥只能是4位)

        private static string Encrypt(string str)
        {//加密字符串

            try
            {
                byte[] key = Encoding.Unicode.GetBytes(encryptKey);//密钥
                byte[] data = Encoding.Unicode.GetBytes(str);//待加密字符串

                DESCryptoServiceProvider descsp = new DESCryptoServiceProvider();//加密、解密对象
                MemoryStream MStream = new MemoryStream();//内存流对象

                //用内存流实例化加密流对象
                CryptoStream CStream = new CryptoStream(MStream, descsp.CreateEncryptor(key, key), CryptoStreamMode.Write);
                CStream.Write(data, 0, data.Length);//向加密流中写入数据
                CStream.FlushFinalBlock();//将数据压入基础流
                byte[] temp = MStream.ToArray();//从内存流中获取字节序列
                CStream.Close();//关闭加密流
                MStream.Close();//关闭内存流

                return Convert.ToBase64String(temp);//返回加密后的字符串
            }
            catch
            {
                return str;
            }
        }


        private static string Decrypt(string str)
        {//解密字符串

            try
            {
                byte[] key = Encoding.Unicode.GetBytes(encryptKey);//密钥
                byte[] data = Convert.FromBase64String(str);//待解密字符串

                DESCryptoServiceProvider descsp = new DESCryptoServiceProvider();//加密、解密对象
                MemoryStream MStream = new MemoryStream();//内存流对象

                //用内存流实例化解密流对象
                CryptoStream CStream = new CryptoStream(MStream, descsp.CreateDecryptor(key, key), CryptoStreamMode.Write);
                CStream.Write(data, 0, data.Length);//向加密流中写入数据
                CStream.FlushFinalBlock();//将数据压入基础流
                byte[] temp = MStream.ToArray();//从内存流中获取字节序列
                CStream.Close();//关闭加密流
                MStream.Close();//关闭内存流

                return Encoding.Unicode.GetString(temp);//返回解密后的字符串
            }
            catch
            {
                return str;
            }
        }

    }
}
