﻿using Microsoft.Practices.ServiceLocation;
using Plane.FormationCreator.ViewModels;
using System.Windows;
using System.Windows.Controls;

namespace Plane.FormationCreator.Views
{
    /// <summary>
    /// Description for LoginView.
    /// </summary>
    public partial class LoginView : Window
    {
        /// <summary>
        /// Initializes a new instance of the LoginView class.
        /// </summary>
        public LoginView()
        {
            InitializeComponent();
            LoginViewModel loginViewModel = ServiceLocator.Current.GetInstance<LoginViewModel>();
            this.DataContext = loginViewModel;
        }
    }
 
}